REBOL [
	Title:  "REBOL Protocols: SMTP"
	Author: "Carl Sassenrath"
	Rights: "Copyright REBOL Technologies 1997-2002"
	; You are free to use, modify, and distribute this software with any
	; REBOL Technologies products as long as the above header, copyright,
	; and this comment remain intact. This software is provided "as is"
	; and without warranties of any kind. In no event shall the owners or
	; contributors be liable for any damages of any kind, even if advised
	; of the possibility of such damage. See license for more information.

	; Please help us to improve this software by contributing changes and
	; fixes via http://www.rebol.com/feedback.html - Thanks!
]

make Root-Protocol [
	{Communicate with SMTP.  This protocol is unusual in that it is
	a write only port.  The data sent to it is considered a command
	unless it begins with the "DATA" string in which case it is
	followed with a message.  There is no URL represenation of this
	entire protocol at this time (but there could be).}

	port-flags: system/standard/port-flags/direct

	open-check:  [ none  "220" ["HELO" system/network/host] "250"]
	close-check: ["QUIT" "221"]
	write-check: [ none  "250"]
	data-check:  ["DATA" "354"]

	write: func [   ;(appears as an insert to the user)
		"Default write operation is a command, so check handshake."
		port "An open port spec"
		data "Data to write"
		/local here
	][
		port: port/sub-port
		either here: find/match data "DATA" [
			net-utils/confirm port data-check
			;!!! need to remove lone "." on a line!
			insert port here
			insert port "."
		][
			net-utils/net-log data
			insert port data
		]
		net-utils/confirm port write-check
	]

	net-utils/net-install SMTP self 25
]
